<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    xmlns:pr="http://www.rm.com/ScorisExternalServices/ProcessedResponse"
    exclude-result-prefixes="xsl pr">
    
  <xsl:output doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN"
    doctype-system="http://www.w3.org/TR/html4/loose.dtd " method="html"
    indent="no" media-type="text/html"/>
  
  <xsl:template match="/">
    <html>
      <xsl:call-template name="htmlHead"/>
      <xsl:call-template name="htmlBody"/>
    </html>
  </xsl:template>
  
  <xsl:template name="htmlHead">
    <head>
      <title>Cambridge Assessment Answers Player</title>
      <script type="text/javascript">
      <![CDATA[
      var loc = document.location.href;
      var base = loc.substring(0, loc.lastIndexOf("/") + 1) + "ReportFiles/";
      document.write('<base href="' + base + '">');
      ]]>
      </script>
      <link href="marking.css" rel="stylesheet"/>
      <script type="text/javascript" src="answersPlayer.js"></script>
      <script type="text/javascript" src="raphael.js"></script>
    </head>
  </xsl:template>

  <xsl:template name="htmlBody">
    <body onload="ap.loadManifest();">
      <div id="answersPlayer">
        <div class="testInfo">
          <span class="label">
            <b>Candidate: </b>
            <xsl:value-of select="//pr:FirstName"/> 
            <xsl:text xml:space="preserve"> </xsl:text>
            <xsl:value-of select="//pr:LastName"/>
          </span>
          <span class="label">
            <b>Date Of Birth: </b>
            <xsl:value-of select="//pr:DateOfBirth"/>
          </span>
          <span class="label">
            <b>Candidate Number: </b>
            <xsl:value-of select="//pr:CandidateNumber"/>
          </span>
        </div>
        <div class="testInfo">
          <span class="label">
            <b>Test: </b> 
            <xsl:value-of select="//pr:TestName"/>
          </span>
          <span class="label">
            <b>Test Code: </b>
            <xsl:value-of select="//pr:TestCode"/>
          </span>
          <span class="label">
            <b>Test Date: </b>
            <xsl:value-of select="//pr:TestDate"/>
          </span>
        </div>
        <div class="testInfo last">
          <span class="label">
            <b>Centre Number: </b>
            <xsl:value-of select="//pr:TestCentreNumber"/>
          </span>
          <span class="label">
            <b>Centre Name: </b>
            <xsl:value-of select="//pr:TestCentreName"/>
          </span>
        </div>
        <div class="answersHeader">
          <span class="label">Question:</span>
          <ul id="navigation"></ul>
          <a href="#" class="printButton" onclick="window.print();return false;">Print Selected</a>
        </div>
        <div id="itemBody"></div>
        <div id="temp" style="display:none"></div>
        <div id="xml" style="display:none">
          <xsl:text disable-output-escaping="yes">&lt;!--CA_START</xsl:text>
            <xsl:copy-of select="."/>
          <xsl:text disable-output-escaping="yes">CA_END--&gt;</xsl:text>
        </div>
      </div>
    </body>
  </xsl:template>

</xsl:stylesheet>
