
// Answers Player
// --------------
// Short term solution, due to the inability 
// to do marking transforms individually server-side.

var ap = (function () {
    var ap = {};
    
    var answersXml = function () { 
        var xmlFromDom = document.getElementById("xml").innerHTML;
        xmlFromDom = xmlFromDom.replace("<!--CA_START", "").replace("CA_END-->", "");
        if (window.DOMParser) {
            // Code for Firefox / Safari
            var parser = new DOMParser();
            // Hack for Safari (explicitly adds placeholder for line breaks)
            if ((navigator.userAgent.indexOf("Safari") !== -1)) {
                xmlFromDom = xmlFromDom.replace(new RegExp( "\\n", "g" ), "SAFARI_LINE_BREAK");
            }      
            return parser.parseFromString(xmlFromDom, "text/xml");
        }
        else {
            // Code for IE
            var answersXmlDoc = new ActiveXObject("Microsoft.XMLDOM");
            answersXmlDoc.async = "false";
            answersXmlDoc.loadXML(xmlFromDom)
            return answersXmlDoc;
        } 
    };
    
    function loadExternalXml (xmlPath) {
        var xhttp;
        if (window.XMLHttpRequest) {
            // Code for Firefox / Safari
            xhttp = new XMLHttpRequest();
        }
        else {
            // Code for IE
            xhttp = new ActiveXObject("Microsoft.XMLHTTP");
        }
        xhttp.open("GET", xmlPath, false);
        xhttp.send("");
        return xhttp.responseXML;
    }
    
    function createNavigationItem (itemId, questionNumber) {
        var navigation = document.getElementById("navigation");
        var li = document.createElement("li");
        var a = document.createElement("a");
        a.href = "#";
        a.innerHTML = questionNumber;
        if (questionNumber == "All") {
            a.style.width = "70px";
            if (document.addEventListener) {
                a.addEventListener("click", function (event) {
                    event.preventDefault();
                    cleanDOM(true);
                    ap.loadAllAnswers();
                }, false);
            }
            else {
                a.attachEvent("onclick", function () {
                    cleanDOM(true);
                    ap.loadAllAnswers();
                    return false;
                });
            }
        }
        else {
            if (document.addEventListener) {
                a.addEventListener("click", function (event) {
                    event.preventDefault();
                    ap.loadItemAnswers(itemId, true, a.innerHTML);
                }, false);
            }
            else {
                a.attachEvent("onclick", function () {
                    ap.loadItemAnswers(itemId, true, a.innerHTML);
                    return false;
                });
            }
        }
        li.appendChild(a);
        navigation.appendChild(li);
    }
    
    function cleanDOM (cleanExistingItem) {
        var tempStore = document.getElementById("temp");

        if (tempStore.hasChildNodes()) {
            while (tempStore.childNodes.length >= 1) {
                tempStore.removeChild(tempStore.firstChild);       
            }
        }        
        if (cleanExistingItem) {
            var itemBody = document.getElementById("itemBody");
            if (itemBody.hasChildNodes()) {
                while (itemBody.childNodes.length >= 1) {
                    itemBody.removeChild(itemBody.firstChild);
                }
            }
        }
    }
       
    function resizeInputs () {
        var x = document.getElementsByTagName('input');
        for (i = 0; i < x.length; i++) {
            if (x[i].type == 'text') {
                var len = x[i].value.length;
                if (len > 1) {x[i].style.width = len+'0px';}
            }
        }
    }
    
    function selectReplacement () {
        var s = document.getElementsByTagName('select');
        for (i = 0; i < s.length; i = i) {
            var inp = document.createElement('input');
            inp.type = 'text';
            inp.readOnly = true;
            var opts = s[i].options;
            for (j = 0; j < opts.length; j++) {
                if (opts[j].selected) {
                    inp.value = opts[j].text;
                }
            }
            inp.className = s[i].className;
            s[i].parentNode.replaceChild(inp, s[i]);
        }
    }
    
    function getElementsByAttribute(el, tag, name, val) {
        var arrElements = (tag == "*" && el.all)? el.all : el.getElementsByTagName(tag);
        var arrReturnElements = new Array();
        var oAttributeValue = (typeof val != "undefined")? new RegExp("(^|\\s)" + val + "(\\s|$)", "i") : null;
        var oCurrent;
        var oAttribute;
        for (var i = 0; i < arrElements.length; i++) {
            oCurrent = arrElements[i];
            oAttribute = oCurrent.getAttribute && oCurrent.getAttribute(name);
            if (typeof oAttribute == "string" && oAttribute.length > 0) {
                if (typeof val == "undefined" || (oAttributeValue && oAttributeValue.test(oAttribute))) {
                    arrReturnElements.push(oCurrent);
                }
            }
        }
        return arrReturnElements;
    }
    
    function columnFloating() {
        var columns = getElementsByAttribute(document.body, 'div', 'data-connect-assess-class', 'column');
        for (var i = 0; i < columns.length; i++) {
            if (i % 2) {
                if (columns[i].style.setAttribute) {
                    columns[i].style.setAttribute('style', 'float: right');
                }
                else {
                    columns[i].style.cssFloat = 'right';
                }
            }
        }
    }
    
    function evaluateScripts() {
        if ((navigator.userAgent.indexOf("Safari") !== -1) || navigator.userAgent.indexOf("MSIE") !== -1) {
            var scripts = itemBody.getElementsByTagName('script');
            for (var i = 0; i < scripts.length; i++) {
                var script = scripts[i];
                if (script.innerHTML != '') {
                    eval(script.innerHTML);
                }
            }
        }
    }
    
    ap.loadAllAnswers = function () {
        var manifestXml = loadExternalXml("clerical-marking-manifest.xml");
        if (document.evaluate) { 
            // Code for Firefox / Safari
            var items = manifestXml.evaluate("//clerical-marking-manifest/items/item/response-transform/@src", 
                manifestXml, null, XPathResult.ANY_TYPE, null);
            
            var item = items.iterateNext();
            var questionNumber = 1;
            while (item) {
                var xslFileName = item.value.replace('clerical-marking/', '');
                ap.loadItemAnswers(xslFileName, false, questionNumber);
                questionNumber++;
                item = items.iterateNext();
            }
        }
        else {
            // Code for IE
            manifestXml.setProperty("SelectionLanguage", "XPath");
            var items = manifestXml.selectNodes("//clerical-marking-manifest/items/item/response-transform/@src");    
            for (var i = 0; i < items.length; i++) {
                var xslFileName = items[i].value.replace('clerical-marking/', '');
                ap.loadItemAnswers(xslFileName, false, i + 1);
            }
        }
        evaluateScripts();
        columnFloating();
        selectReplacement();
        resizeInputs();
    };
    
    ap.loadItemAnswers = function (itemId, individual, questionNumber) {
        var tempStore = document.getElementById("temp");
        var itemBody = document.getElementById("itemBody");
        var itemXsl = loadExternalXml(itemId);
        var title = document.createElement("h1");
        title.innerHTML = "Question " + questionNumber;
        try {
            if (window.ActiveXObject) {
                // Code for IE
                var result = answersXml().transformNode(itemXsl);
                cleanDOM(individual);
                tempStore.innerHTML = result;
                var toAttach = tempStore.firstChild;
                itemBody.appendChild(title);
                itemBody.appendChild(tempStore.firstChild);
                itemBody.appendChild(document.createElement("hr"));
            }
            else if (document.implementation && document.implementation.createDocument) {
                // Code for Firefox / Safari
                var xsltProcessor = new XSLTProcessor();
                
                // Hack for Safari (passes a parameter to the xslt)
                if ((navigator.userAgent.indexOf("Safari") !== -1)) {
                    xsltProcessor.setParameter(null, "browser", "safari");
                }
                
                xsltProcessor.importStylesheet(itemXsl);
                var result = xsltProcessor.transformToFragment(answersXml(), document);
                tempStore.appendChild(result);
                var processedResult = document.getElementsByTagName("body")[1].firstChild;
                cleanDOM(individual);
                itemBody.appendChild(title);
                itemBody.appendChild(processedResult);
                itemBody.appendChild(document.createElement("hr"));
            }
            if (individual) {
                evaluateScripts();
                columnFloating();
                selectReplacement();
                resizeInputs();
            }
        }
        catch (ex) {
            alert("Failed to load answer:\n" + ex);
        }
    };
    
    ap.loadManifest = function () {
        try {
            var manifestXml = loadExternalXml("clerical-marking-manifest.xml");       
            if (document.evaluate) { 
                // Code for Firefox / Safari
                var items = manifestXml.evaluate("//clerical-marking-manifest/items/item/response-transform/@src", 
                    manifestXml, null, XPathResult.ANY_TYPE, null);
                var questionNumber = 1;
                
                var item = items.iterateNext();
                while (item) {
                    var xslFileName = item.value.replace('clerical-marking/', '');
                    if (questionNumber == 1) {
                        ap.loadItemAnswers(xslFileName, true, 1);
                    }
                    createNavigationItem(xslFileName, questionNumber)
                    questionNumber++;
                    item = items.iterateNext();
                }
                createNavigationItem("All", "All");
            }
            else {
                // Code for IE
                manifestXml.setProperty("SelectionLanguage", "XPath");
                var items = manifestXml.selectNodes("//clerical-marking-manifest/items/item/response-transform/@src");    
                for (var i = 0; i < items.length; i++) {
                    var xslFileName = items[i].value.replace('clerical-marking/', '');
                    if (i == 0) {
                        ap.loadItemAnswers(xslFileName, true, 1);
                    }
                    createNavigationItem(xslFileName, i + 1)
                }
                createNavigationItem("All", "All")
            }
        }
        catch (ex) {
            document.getElementsByTagName("body")[0].style.display = "none";
            alert("Failed to load answers:\n" + ex);
        }
    };
    
    return ap;
}());