var ca = (function () {
    var ca = {};
    var XUL_NS = 'http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul';
    var SIZES = [[800, 600], [1024, 768], [1280, 1024]];
    var windowEl = document.documentElement;
    ca.browser = function () { return document.getElementById("browser1"); };
    var browser = ca.browser();
    var arguments = window.arguments[0];
    arguments = arguments.QueryInterface(Components.interfaces.nsICommandLine);
    var screenWidth = window.screen.width;
    var screenHeight = window.screen.height;   
    var title = arguments.handleFlagWithParam('title', false);
    var isCtrl = false;
    var hasColourStyle = false;
    var LIBSUri;

    const STATE_START = Components.interfaces.nsIWebProgressListener.STATE_START;
    const STATE_STOP = Components.interfaces.nsIWebProgressListener.STATE_STOP;
    accessibilityApiListener = {
        QueryInterface: function(aIID) {
            if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
                aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
                aIID.equals(Components.interfaces.nsISupports))
                return this;
            throw Components.results.NS_NOINTERFACE;
        },

        onStateChange: function(aWebProgress, aRequest, aFlag, aStatus) {
            // If you use the listener for more than one tab/window, use
            // aWebProgress.DOMWindow to obtain the tab/window which triggers the state change
            // https://developer.mozilla.org/en/Code_snippets/Progress_Listeners
            if(aFlag & STATE_START) {
                aWebProgress.DOMWindow.wrappedJSObject.accessAPI = {
                    styles: function (num) {
                        ca.styleChange(num);
                    },
                    zoom: function (num) {
                        ca.zoom(num);
                    },
                    setScreenResolution: function (num) {
                        ca.setSize(num);
                    },
                    closeWindow: function () {
                        ca.closeWindow();
                    },
                    getScreenResolution: function () {
                        return {
                            height: browser.clientHeight,
                            width: browser.clientWidth
                        };
                    },
                    getCurrentZoom: function () {
                        return browser.markupDocumentViewer.fullZoom;
                    }
                };
            }
        }
    };
    
    function addAccessibilityApi () {
        browser.addProgressListener(accessibilityApiListener);
        browser.setAttribute('src', LIBSUri);
        document.removeEventListener("DOMContentLoaded", addAccessibilityApi, null);
        ZoomManager.useFullZoom = true;
    }
    document.addEventListener("DOMContentLoaded", addAccessibilityApi, null);
    
    function setTitle () {    
        if (title !== null) {
            title += ' - Preview';
            windowEl.setAttribute('title', title);
        }
    }
    setTitle();

   
    if (arguments.length >= 1) {
        var uri = arguments.getArgument(0);
        uri = arguments.resolveURI(uri);
        LIBSUri = uri.spec;
    }

    ca.styleChange = function (num) {
        var docElement = browser.contentDocument.documentElement;
        var head = docElement.getElementsByTagName("head")[0];
        var url = "colour" + num + ".css";
        
        if (hasColourStyle) {
            var links = head.getElementsByTagName("link");
            var len = links.length;
            var newLen = len - 2;
            while (newLen < len) {
                var link = links[newLen];
                if (link.getAttribute("id") === "colourStyle") {
                    link.setAttribute("href", url);
                    break;
                }
                newLen += 1;
            }
        } else {
            var newLink = document.createElementNS("http://www.w3.org/1999/xhtml", "link");
            newLink.setAttribute("href", url);
            newLink.setAttribute("rel", "stylesheet");
            newLink.setAttribute("id", "colourStyle");

            head.appendChild(newLink);
        }

        hasColourStyle = true;
    };

    ca.increase = function () {
        ZoomManager.enlarge();
    };

    ca.decrease = function () {
        ZoomManager.reduce();
    };

    ca.reset = function () {
        ZoomManager.reset();
    };

    ca.zoom = function (num) {
        browser.markupDocumentViewer.fullZoom = num;
    };
    

    // KEY PRESS DETECTION
    function keyboardTextResize (e) {
        var k = e.which;
        if (k === 17) {
            isCtrl = true; 
        }

        if (isCtrl) {
            switch (k) {
                case 107:
                    ca.increase();
                    break;
                case 109:
                    ca.decrease();
                    break;
                case 48:
                    ca.reset();
                    break;
                default:
                    break;
            }
        }
    }

    function ctrlCheck (e) {
        if (e.which === 17) {
            isCtrl = false;
        }
    }

    // full zoom on key press removed so as not to conflict with browser controlled full zooming
    //document.addEventListener('keydown', keyboardTextResize, true);
    //document.addEventListener('keyup', ctrlCheck, true);

    ca.setSize = function(size) {
        if (size === 3) {
            window.fullScreen = true;
        } else {
            window.fullScreen = false;
            var s = SIZES[size];
            var width = s[0];
            var height = s[1];

            var windowWidth = window.outerWidth;
            var contentWidth = browser.clientWidth;
            windowWidth = width + windowWidth - contentWidth;
            
            var windowHeight = window.outerHeight;
            var contentHeight = browser.clientHeight;
            windowHeight = height + windowHeight - contentHeight;
            
            window.resizeTo(windowWidth, windowHeight);
        }
    };

    ca.closeWindow = function() {
        window.close();
    };
    return ca;
}());

// function required by ZoomManager
function getBrowser() {
    return ca.browser();
}

